<?php
/**
 * DokuWiki Plugin oreqr (Syntax Component) ver 0.0.1
 *
 * @license GPL 2 http://www.gnu.org/licenses/gpl-2.0.html
 * @author  ore <orebike@gmail.com>
 */

// must be run within Dokuwiki
if (!defined('DOKU_INC')) die();

if (!defined('DOKU_LF')) define('DOKU_LF', "\n");
if (!defined('DOKU_TAB')) define('DOKU_TAB', "\t");
if (!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');

require_once DOKU_PLUGIN.'syntax.php';

class syntax_plugin_oreqr extends DokuWiki_Syntax_Plugin {
    function getType() { return 'substition'; }
    function getPType() { return 'normal'; }
    function getSort() { return 300; }
    function connectTo($mode) {
        $this->Lexer->addSpecialPattern('\{\{qr>.*?\}\}',$mode,'plugin_oreqr');
    }

    function handle($match, $state, $pos, &$handler){
        //pick up param
        $match = substr($match, 5, -2);
        $data = array("to_qr_text" => $match);

        return $data;
    }

    function render($mode, &$renderer, $data) {
        if($mode != 'xhtml') return false;
        
        $qr_service_url = 'http://chart.apis.google.com/chart?chs=128x128&cht=qr&chl=';
        $text_param = urlencode($data["to_qr_text"]);
        
        $renderer->doc .= '<img src="' . $qr_service_url . $text_param . '" />';
        return true;
    }
}
